`timescale 1ns / 1ps
module ArithmeticUnit(
	output validOut,
	output [63:0] elementOut,
	output [9:0]memAddrOut,
	input validIn,
	input [15:0] groupOffset,
	input [9:0]memAddrIn,
	input [31:0] a1,
	input [31:0] d,
	input [15:0] N,
	input clock
);

reg validReg;
reg [31:0]iReg, a1Reg, dReg;
reg [9:0]memAddrReg;

wire [31:0]iFromOffset, iFromReg;
wire validFromOffset, validFromReg;
wire [9:0]memAddrFromOffset, memAddrFromReg;

assign iFromReg = iReg;
assign validFromReg = validReg;
assign memAddrFromReg = memAddrReg;

OffsetBlock offset(.groupOffset(groupOffset), .validIn(validIn), .memAddrIn(memAddrIn), .N(N), .clock(clock), .i(iFromOffset), .validOut(validFromOffset), .memAddrOut(memAddrFromOffset));
SequenceBlock seq(.validIn(validFromReg), .memAddrIn(memAddrFromReg), .i(iFromReg), .a1(a1Reg), .d(dReg), .clock(clock), .elementOut(elementOut), .memAddrOut(memAddrOut));

// pipeline stage:
always @(posedge clock) begin
	iReg <= iFromOffset;
	validReg <= validFromOffset;
	memAddrReg <= memAddrFromOffset;
	a1Reg <= a1;
	dReg <= d;
end

endmodule
