`timescale 1ns / 1ps

module FullAdder4(
	output[3:0] sum,
	output carryOut,
	input [3:0] inA,
	input [3:0] inB,
	input carryIn
    
	);
	 
	 wire carry0, carry1, carry2, carry3;
	 assign carryOut = carry3;
	 FullAdder fa0(.inA(inA[0]), .inB(inB[0]), .carryIn(carryIn), .carryOut(carry0));
	 FullAdder fa1(.inA(inA[1]), .inB(inB[1]), .carryIn(carry0), .carryOut(carry1));
	 FullAdder fa2(.inA(inA[2]), .inB(inB[2]), .carryIn(carry1), .carryOut(carry2));
	 FullAdder fa3(.inA(inA[3]), .inB(inB[3]), .carryIn(carry2), .carryOut(carry3));
endmodule
